#include <sys/os32.h>
#include <kernel/memory.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
//----------------------------------------------------------------------
uint32_t        mb_table[MEM_MAX_BLOCKS / 32];	// Memory blocks map.
unsigned int    mb_max = MEM_MAX_BLOCKS;	// Memory blocks max.
//----------------------------------------------------------------------
int
main (int argc, char *argv[], char *envp[])
{
  unsigned int    block;
  unsigned int    blocks = MEM_MAX_BLOCKS;
  int             i;
  int             j;
  uint32_t        mask;
  unsigned int    start = 0;
  unsigned int    stop = 0;
  unsigned int    status = 0;
  int             fd;
  ssize_t         size_read;
  char           *buffer = (char *) mb_table;
  //
  fd = open ("/dev/kmem_map", O_RDONLY);
  if (fd < 0)
    {
      printf ("[%s] Cannot open \"/dev/kmem_map\" ", argv[0]);
      perror (NULL);
      return (0);
    }
  //
  lseek (fd, (off_t) 0, SEEK_SET);
  for (i = 0; i < (MEM_MAX_BLOCKS / 8); i += size_read)
    {
      size_read = read (fd, &buffer[i], BUFSIZ);
      if (size_read < 0)
	{
	  printf ("[%s] Cannot read \"/dev/kmem_map\" %i %i  ",
		  argv[0], size_read, sizeof (mb_table));
	  perror (NULL);
	  return (0);
	}
    }
  //
  printf ("Hex mem map, blocks of %x:", MEM_BLOCK_SIZE);
  //
  for (block = 0; block < blocks; block++)
    {
      i = block / 32;
      j = block % 32;
      mask = 0x80000000 >> j;
      if (mb_table[i] & mask)
	{
	  //
	  // Allocated block
	  //
	  if (status == 0)
	    {
	      status = 1;
	      start = block;
	    }
	}
      else
	{
	  //
	  // Not allocated block.
	  //
	  if (status == 1)
	    {
	      status = 0;
	      stop = block;
	    }
	}
      //
      //
      //
      if (stop > 0)
	{
	  printf (" %x-%x", start, stop);
	  start = 0;
	  stop = 0;
	}
    }
  printf ("\n");

  return (0);
}
