#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <signal.h>
#include <sys/wait.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
//----------------------------------------------------------------------
int
main (void)
{
  int             fd;
  pid_t           child;
  char            buffer;
  char           *message = "ciao a tutti voi amici vicini e lontani\n";
  int             i;
  size_t          size;
  ssize_t         written;
  int             status;
  //
  //
  //
  unlink ("/tmp/fifo");
  //
  status = mknod ("/tmp/fifo", S_IFIFO | S_IRUSR | S_IWUSR, 0);
  if (status != 0)
    {
      perror ("mknod fifo");
      exit (EXIT_FAILURE);
    }
  //
  //
  //
  child = fork ();
  if (child == -1)
    {
      perror ("fork");
      exit (EXIT_FAILURE);
    }
  //
  //
  //
  if (child == 0)
    {
      //
      // This is the child and it have to read the fifo.
      //
      fd = open ("/tmp/fifo", O_RDONLY);
      if (fd < 0)
	{
	  perror ("fifo read open");
	  exit (EXIT_FAILURE);
	}
      //
      // Read one byte at the time, as long as there is
      // something to read.
      //
      while (read (fd, &buffer, 1) > 0)
	{
	  write (STDOUT_FILENO, &buffer, 1);
	}
      //
      // Close the fifo and exit the child.
      //
      close (fd);
      //
      exit (EXIT_SUCCESS);
    }
  else
    {
      //
      // This is the parent process and it writes to the FIFO.
      //
      fd = open ("/tmp/fifo", O_WRONLY);
      if (fd < 0)
	{
	  perror ("fifo write open");
	  exit (EXIT_FAILURE);
	}
      //
      while (1)
	{
	  for (i = 0, written = 0, size = strlen (message);
	       i < strlen (message); i += written, size -= written)
	    {
	      written = write (fd, &message[i], size);
	      if (written < 0)
		{
		  perror ("pipe");
		  close (fd);
		  wait (NULL);	// Wait for child.
		  exit (EXIT_FAILURE);
		}
	    }
	}
      close (fd);		/* Reader will see EOF */
      wait (NULL);		/* Wait for child */
      exit (EXIT_SUCCESS);
    }
  //
  return (0);
}
