#include <kernel/driver/screen.h>
#include <errno.h>
//----------------------------------------------------------------------
int
screen_clear (screen_t *screen)
{
    int j;
    //
    // Check argument.
    //
    if (screen == NULL)
      {
        errset (EINVAL);
        return (-1);
      }
    //
    // Clear the virtual screen.
    //
    for (j = 0; j < SCREEN_CELLS; j++)
      {
        screen->cell[j] = screen_cell (' ', VGA_ATTR);
      }
    //
    // Place the cursor at the top.
    //
    screen->position = 0;
    //
    // Update the screen if it is the active one.
    //
    screen_update (screen);
    //
    // Ok.
    //
    return (0);
}
