#include <sys/os32.h>
#include <kernel/driver/tty.h>
#include <kernel/driver/screen.h>
//----------------------------------------------------------------------
dev_t
tty_console (dev_t device)
{
    static dev_t     device_active = DEV_CONSOLE0;  // First time.
           dev_t     device_previous;
           screen_t *screen;
    //
    // Check if it required only the current device.
    //
    if (device == 0)
      {
        return (device_active);
      }
    //
    // Fix if the device is not valid.
    //
    if (device > DEV_CONSOLE3 || device < DEV_CONSOLE0)
      {
        device = DEV_CONSOLE0;
      }
    //
    // Update.
    //
    device_previous = device_active;
    device_active   = device;
    //
    // Get screen pointer.
    //
    screen = screen_pointer ((int) (device_active & 0x00FF));
    //
    // Switch.
    //
    screen_select (screen);
    //
    // Return previous device value.
    //
    return (device_previous);
}
