#include <sys/os32.h>
#include <kernel/driver/tty.h>
#include <kernel/lib_k.h>
//----------------------------------------------------------------------
int
tty_read (dev_t device)
{
    tty_t   *tty;
    int      key;
    //
    tty = tty_reference (device);
    if (tty == NULL)
      {
        k_printf ("kernel alert: cannot find terminal device "
                  "0x%08x!\n", (int) device);
        //
        return (-1);
      }
    //
    // Read from canonical input line, but only if it is time to read.
    //
    if (tty->status == TTY_INPUT_LINE_CLOSED)
      {
        if (tty->lpr > tty->lpw)
          {
            //
            // There is nothing to read!
            // Reset input line.
            //
            tty->lpw = 0;
            tty->lpr = 0;
            tty->status = TTY_INPUT_LINE_EDITING;
            //
            return (-1);
          }
        //
        // Read the key.
        //
        key = tty->line[tty->lpr];
        //
        // Move up the read cursor.
        //
        tty->lpr++;
      }
    else
      {
        return (-1);
      }
    //
    // Return the key.
    //
    return (key);

}
