#include <sys/os32.h>
#include <kernel/fs.h>
#include <kernel/dev.h>
#include <errno.h>
//----------------------------------------------------------------------
void
zone_print (sb_t *sb, zno_t zone)
{
    char buffer[SB_MAX_ZONE_SIZE];
    int status;
    int i;
    int x;
    //
    status = zone_read (sb, zone, buffer);
    //
    if (status < 0)
      {
        k_perror (NULL);
        return;
      }
    //
    // Print.
    //
    k_printf ("dev: 0x%04x, first dzone: %i zone read: %i\n",
              sb->device, sb->first_data_zone, zone);
    //
    // Will print at most the first 256 byte only!
    //
    for (i = 0; i < sb->blksize && i < 256; i++)
      {
        k_printf ("%02x ", buffer[i]);
        x = (i+1) % 4;
        if (x == 0 && i > 0)
          {
            k_printf ("| ");
          }
        x = (i+1) % 16;
        if (x == 0 && i > 0)
          {
            k_printf ("\n");
          }
      }
}
