#include <kernel/lib_k.h>
#include <kernel/lib_s.h>
#include <kernel/proc.h>
#include <time.h>
//----------------------------------------------------------------------
unsigned int
k_sleep (unsigned int seconds)
{
  clock_t                time_start;
  clock_t                time_now;
  clock_t                time_elapsed;
  clock_t                time = seconds * CLOCKS_PER_SEC;
  unsigned long long int loops;
  //
  // Calculate how many times the following loop should
  // be run to get the requested time.
  //
  loops = proc_loops_per_clock * time;
  //
  // Do a wasting time loop.
  //
  time_elapsed       = 0;
  time_start         = s_clock ((pid_t) 0);
  //
  // If the function `s_clock()' can help, it will
  // exit even if the loop is become slow, but the
  // time was correctly accounted and is elapsed.
  //
  for (; time_elapsed < time && loops > 0; loops--)
    {
      time_now = s_clock ((pid_t) 0);
      time_elapsed = time_now - time_start;
    }
  //
  // The sleep is always complete.
  //
  return (0);
}
