#include <kernel/lib_k.h>
#include <stdio.h>
#include <kernel/dev.h>
//----------------------------------------------------------------------
int
k_vprintf (const char *restrict format, va_list arg)
{
    size_t size = BUFSIZ;
    char   string[BUFSIZ];
    int    status;
    //
    // At the moment, set `string' to be a null string.
    //
    string[0] = 0;
    //
    // Get the string, that must be limited to `size'
    // bytes.
    //
    status = vsnprintf (string, size, format, arg);
    //
    //
    //
    if (status < 0)
      {
        //
        // Variable `errno' is not updated.
        //
        return (status);
      }
    //
    // Get size.
    //
    size = status;
    //
    // Write to the first console.
    //
    dev_io ((pid_t) 0, DEV_CONSOLE0, DEV_WRITE, (off_t) 0,
            string, size, NULL);
    //
    // Return the same value obtained from `vsnprintf()'
    //
    return status;
}
