#include <errno.h>
#include <kernel/proc.h>
#include <kernel/lib_k.h>
#include <kernel/lib_s.h>
//----------------------------------------------------------------------
void           *
s_sbrk (pid_t pid, intptr_t increment)
{
  size_t          previous_size;
  size_t          new_size;
  int             status;
  //
  // Get current data segment full size.
  //
  if (proc_table[pid].domain_data == 0)
    {
      previous_size = (proc_table[pid].domain_text
		       + proc_table[pid].extra_data);
    }
  else
    {
      previous_size = (proc_table[pid].domain_data
		       + proc_table[pid].extra_data);
    }
  //
  // Check increment.
  //
  if ((increment + proc_table[pid].extra_data) < 0)
    {
      //
      // Cannot reduce too much. Just correct it.
      //
      increment = -proc_table[pid].extra_data;
    }
  //
  // Calculate the new size.
  //
  new_size = previous_size + increment;
  //
  // Call `s_brk()' to do the work. The new size value is the
  // same of the new requested pointer address.
  //
  status = s_brk (pid, (void *) new_size);
  //
  if (status < 0)
    {
      errset (errno);
      return ((void *) -1);
    }
  //
  // Ok: return previous final address.
  //
  return ((void *) previous_size);
}
