#include <kernel/proc.h>
#include <kernel/lib_s.h>
#include <errno.h>
//----------------------------------------------------------------------
int
s_setegid (pid_t pid, gid_t egid)
{
  if ((proc_table[pid].euid == 0) || (proc_table[pid].egid == 0))
    {
      proc_table[pid].egid = egid;
      return (0);
    }
  else if (egid == proc_table[pid].egid)
    {
      return (0);
    }
  else if (egid == proc_table[pid].gid || egid == proc_table[pid].sgid)
    {
      proc_table[pid].egid = egid;
      return (0);
    }
  else
    {
      errset (EPERM);
      return (-1);
    }
}
