#include <kernel/memory.h>
#include <kernel/ibm_i386.h>
#include <sys/os32.h>
#include <kernel/lib_k.h>
#include <kernel/multiboot.h>
//----------------------------------------------------------------------
void
mb_print (void)
{
    unsigned int block;
    unsigned int blocks = (multiboot.mem_upper * 1024 / MEM_BLOCK_SIZE);
    int          i;
    int          j;
    uint32_t     mask;
    unsigned int start = 0;
    unsigned int stop  = 0;
    unsigned int status = 0;
    //
    k_printf ("Hex mem map, blocks of %x:", MEM_BLOCK_SIZE);
    //
    for (block = 0; block < blocks; block++)
      {
        i    = block / 32;
        j    = block % 32;
        mask = 0x80000000 >> j;
        if (mb_table[i] & mask)
          {
            //
            // Allocated block
            //
            if (status == 0)
              {
                status = 1;
                start = block;
              }
          }
        else
          {
            //
            // Not allocated block.
            //
            if (status == 1)
              {
                status = 0;
                stop = block;
              }
          }
        //
        //
        //
        if (stop > 0)
          {
            k_printf (" %x-%x", start, stop);
            start = 0;
            stop  = 0;
          }
      }
    k_printf ("\n");
}
