#include <kernel/memory.h>
#include <kernel/ibm_i386.h>
#include <sys/os32.h>
#include <errno.h>
//----------------------------------------------------------------------
int
mb_reduce (addr_t address, size_t new, size_t previous)
{
    addr_t start;
    addr_t end;
    size_t size;
    //
    //
    //
    if (new > previous)
      {
        //
        // We are reducing, not extending!
        //
        errset (EINVAL);
        return (-1);
      }
    //
    //
    //
    if (new == previous)
      {
        //
        // Nothing to do.
        //
        return (0);
      }
    //
    // Correct sizes to conform to memory blocks.
    //
    start = address + new;
    if (start % MEM_BLOCK_SIZE)
      {
        start /= MEM_BLOCK_SIZE;
        start++;
        start *= MEM_BLOCK_SIZE;
      }
    //
    end = address + previous;
    end /= MEM_BLOCK_SIZE;
    end *= MEM_BLOCK_SIZE;
    //
    size = end - start;
    //
    // Finally release the extra memory, no more used.
    //
    mb_free (start, size);
    //
    // Ok.
    //
    return (0);
}
