#ifndef _KERNEL_NET_ICMP_H
#define _KERNEL_NET_ICMP_H    1
//----------------------------------------------------------------------
#include <stdint.h>
#include <sys/types.h>
#include <kernel/net/ip.h>
#include <netinet/icmp.h>
//----------------------------------------------------------------------
#define ICMP_HEADER_SIZE   8
#define ICMP_MAX_PACKET_SIZE  NET_IP_MAX_DATA_SIZE
#define ICMP_MAX_DATA_SIZE    ICMP_MAX_PACKET_SIZE-ICMP_HEADER_SIZE
//----------------------------------------------------------------------
//
// ICMP packet, for transmission.
//
typedef struct {
  struct icmphdr header;
  uint8_t        data[ICMP_MAX_DATA_SIZE];
} __attribute__ ((packed)) icmp_packet_t;

//----------------------------------------------------------------------
int icmp_rx             (int i);
//
int icmp_tx             (h_addr_t src, h_addr_t dst,
                         int type, int code, icmp_packet_t *icmp,
                         size_t size);
//
int icmp_tx_echo        (h_addr_t src, h_addr_t dst,
                         int type, int code,
                         int identifier, int sequence,
                         uint8_t *data, size_t size);
//
int icmp_tx_unreachable (h_addr_t src, h_addr_t dst, int type,
                         int code, uint8_t *data, size_t size);
//
//----------------------------------------------------------------------
#endif
