#include <sys/os32.h>
#include <kernel/driver/nic/ne2k.h>
#include <kernel/driver/pci.h>
#include <kernel/ibm_i386.h>
#include <errno.h>
//----------------------------------------------------------------------
net_buffer_eth_t *
net_buffer_eth (int n)
{
  int     b;                    // Buffer index.
  int     ref = -1;             // Reference index.
  clock_t clock = k_clock ();   // Reference clock value.
  //
  // Check Ethernet index.
  //
  if ((n > NET_MAX_DEVICES) || (n < 0))
    {
      errset (EINVAL);
      return (NULL);
    }
  //
  if (!(net_table[n].type & NET_DEV_ETH))
    {
      errset (EINVAL);
      return (NULL);
    }
  //
  // Ethernet found.
  //
  for (b = 0; b < NET_MAX_BUFFERS; b++)
    {
      if (net_table[n].ethernet.buffer[b].clock == 0)
        {
          //
          // Enough.
          //
          return &net_table[n].ethernet.buffer[b];
        }
      else if (net_table[n].ethernet.buffer[b].clock < clock)
        {
          clock = net_table[n].ethernet.buffer[b].clock;
          ref = b;
        }
    }
  //
  // Return the selected frame structure.
  //
  return &net_table[n].ethernet.buffer[ref];
  //
  // Device not found!
  //
  errset (ENODEV);
  return (NULL);
}
