#include <sys/os32.h>
#include <kernel/net.h>
#include <errno.h>
//----------------------------------------------------------------------
void
net_print (void)
{
  int n;        // NET devices table index.
  char string[80];
  //
  //
  //
  k_printf ("dev   "
            "address/mask        "
            "mac                "
            "io      irq\n");
  //
  for (n = 0; n < NET_MAX_DEVICES; n++)
    {
      if (net_table[n].type != NET_DEV_NULL)
        {
          sprintf (string, "net%i    ", n);
          string[6] = '\0';
          k_printf ("%s", string);
          //
          sprintf (string, "%i.%i.%i.%i/%i "
                           "               ",
                   net_table[n].ip >> 24 & 0x000000FF,
                   net_table[n].ip >> 16 & 0x000000FF,
                   net_table[n].ip >>  8 & 0x000000FF,
                   net_table[n].ip >>  0 & 0x000000FF,
                   net_table[n].m);
          string[20] = '\0';
          k_printf ("%s", string);
          //
          if (net_table[n].type & NET_DEV_ETH)
            {
              k_printf ("%02x:%02x:%02x:%02x:%02x:%02x  0x%04x  %i",
                     net_table[n].ethernet.mac[0],
                     net_table[n].ethernet.mac[1],
                     net_table[n].ethernet.mac[2],
                     net_table[n].ethernet.mac[3],
                     net_table[n].ethernet.mac[4],
                     net_table[n].ethernet.mac[5],
                     net_table[n].ethernet.base_io,
                     net_table[n].ethernet.irq);
            }
          k_printf ("\n");
        }
    }
}
