#include <kernel/proc.h>
#include <fcntl.h>
#include <kernel/lib_s.h>
#include <kernel/lib_k.h>
//----------------------------------------------------------------------
void
proc_dump_memory (pid_t pid, addr_t address, size_t size, char *name)
{
    int     fdn;
    char    buffer[BUFSIZ];
    ssize_t size_written;
    ssize_t size_written_total;
    ssize_t size_read;
    ssize_t size_read_total;
    ssize_t size_total = 0;
    //
    // Dump the code segment to disk.
    //
    fdn = s_open (pid, name, (O_WRONLY|O_CREAT|O_TRUNC),
                   (mode_t) (S_IFREG|00644));
    if (fdn < 0)
      {
        //
        // There is a problem: just let it go.
        //
        k_perror (NULL);
        return;
      }
    //
    // Read the memory and write it to disk.
    //
    for (size_read = 0, size_read_total = 0;
         size_read_total < size_total;
         size_read_total += size_read, address += size_read)
      {

        size_read = dev_io ((pid_t) 0, DEV_MEM, DEV_READ,
                            (off_t) address, buffer,
                            (size_t) BUFSIZ, NULL);
        //
        for (size_written = 0, size_written_total = 0;
             size_written_total < size_read;
             size_written_total += size_written)
          {
            size_written = s_write (pid, fdn,
                            &buffer[size_written_total],
                            (size_t) (size_read - size_written_total));
            //
            if (size_written < 0)
              {
                s_close (pid, fdn);
                return;
              }
          }
      }
    s_close (pid, fdn);
}
