#include <kernel/proc.h>
#include <kernel/lib_k.h>
#include <sys/types.h>
//----------------------------------------------------------------------
void
proc_wakeup_terminal (void)
{
    pid_t pid;
    int   maj;
    //
    // At the moment, all processes waiting for reading a terminal
    // or the console are reactivated.
    //
    for (pid = 0; pid < PROCESS_MAX; pid++)
      {
        if (   (proc_table[pid].status == PROC_SLEEPING)
            && (proc_table[pid].wakeup_events & WAKEUP_EVENT_DEV_READ))
          {
            maj = major (proc_table[pid].wakeup_dev);
            if (maj == DEV_TTY_MAJOR || maj == DEV_CONSOLE_MAJOR)
              {
                //
                // A process waiting for that terminal was found:
                // remove the waiting event and set it ready.
                //
                proc_table[pid].wakeup_events &= ~WAKEUP_EVENT_DEV_READ;
                proc_table[pid].wakeup_dev = 0;
                proc_table[pid].status = PROC_READY;
              }
          }
      }
}
