#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/os32.h>
//----------------------------------------------------------------------
int
execlp (const char *path, char *arg, ...)
{
    int   argc;
    char *arg_next;
    char *argv[ARG_MAX/2];
    char  command[PATH_MAX];
    int   status;
    //
    va_list ap;
    va_start (ap, arg);
    //
    arg_next = arg;
    //    
    for (argc = 0; argc < ARG_MAX/2; argc++)
      {
	argv[argc] = arg_next;
	if (argv[argc] == NULL)
	  {
	    break;	// End of arguments.
	  }
	arg_next = va_arg (ap, char *);
      }
    //
    // Get a full command path if necessary.
    //
    status = namep (path, command, (size_t) PATH_MAX);
    if (status != 0)
      {
	//
	// Variable `errno' is already set by `commandp()'.
	//
        return (-1);
      }
    //
    // Return calling `execve()'
    //
    return (execve (command, argv, environ));	// [1]
}
//
// The variable `environ' is declared as `char **environ' and is
// included from <unistd.h>.
//
